Bug 875116 - epub output has problems with internal identifiers (id), either missing or duplicate
epub output has problems with internal identifiers (id), either missing or du...
Status: CLOSED CURRENTRELEASE
Product: Publican
Classification: Community
Component: publican (Show other bugs)
3.0
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jeff Fearn
tools-bugs
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-11-09 10:06 EST by Raphaël Hertzog
Modified: 2013-12-18 21:46 EST (History)
3 users (show)

See Also:
Fixed In Version: 4.0.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-12-18 21:46:48 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Raphaël Hertzog 2012-11-09 10:06:21 EST
Following up with #701667, this ticket is meant to track the problems of the EPUB output concerning the management of "id" attributes. With epubcheck 3.0-RC1 you can easily get errors like this:

ERROR: /home/rhertzog/x/tdah/publish/en-US/Debian/6.0/epub/debian-handbook/Debian-6.0-debian-handbook-en-US.epub: could not parse OEBPS/sect.virtualization.html: duplicate id: virtinst.connect

or like this:

ERROR: /home/rhertzog/x/tdah/publish/en-US/Debian/6.0/epub/debian-handbook/Debian-6.0-debian-handbook-en-US.epub/OEBPS/toc.ncx(2,55180): 'idp27426448': fragment identifier is not defined in 'OEBPS/sect.windows-file-server-with-samba.html'

Those errors here have been reproduced with the book the Debian Handbook:
$ git clone git://anonscm.debian.org/debian-handbook/debian-handbook.git
Comment 1 Jeff Fearn 2013-09-30 02:24:47 EDT
I believe this was fixed in Publican 3.1 as we reverted the anchor code.
Comment 2 Raphaël Hertzog 2013-09-30 12:09:17 EDT
Most of the problems seem to be solved indeed but I still have some warnings related to "id" management. The duplicate "id" warning persists.

I have the issue when the "id" is on a <para>.

 <para id="dsa-team">The DSA team...</para>
 <para>....<link linkend="dsa-team">Debian System Administrators</link>...</para>

I end up with something like this:
 
 <div class="para" id="dsa-team"><a xmlns="" id="dsa-team"/>

Or with callouts (in examples or code areas):

 <co id="smb.conf.wins"/>

For those, the id appears on the inline callout number and in the callout list that describes those callouts.

I also have some other warnings with bad anchors in toc.ncx:

ERROR: publish/en-US/Debian/7.0/epub/debian-handbook/Debian-7.0-debian-handbook-en-US.epub/OEBPS/toc.ncx(2,5706): 'idm140125705857200': fragment identifier is not defined in 'OEBPS/sect.debian-internals.html'
ERROR: publish/en-US/Debian/7.0/epub/debian-handbook/Debian-7.0-debian-handbook-en-US.epub/OEBPS/toc.ncx(2,59957): 'idm140125697874416': fragment identifier is not defined in 'OEBPS/sect.windows-file-server-with-samba.html'

Though here I'm not sure the warning is correct. I find the corresponding id tags in the given files. It seems to occur on deeply nested titles but I don't know why.

This can still be reproduced with the book in the git respository indicated in the initial report.
Comment 3 HSS Product Manager 2013-09-30 20:07:38 EDT
HSS-QE has reviewed and declined this request. QE for this bug will be handled by IED.
Comment 4 Jeff Fearn 2013-09-30 20:09:12 EDT
Fixed callouts having duplicate IDs in all HTML outputs. Fixed various other EPUB specific instances.


To ssh://git.fedorahosted.org/git/publican.git
   8711fbe..9d087c5  HEAD -> devel
Comment 5 Ruediger Landmann 2013-10-10 20:54:17 EDT
I generated an epub with publican-3.9.9-0.fc19.t4.noarch and checked it with epubcheck-3.0.1 -- the only errors I got were connected with the title_logo.svg, not the book itself. 


$ java -jar epubcheck-3.0.1.jar /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub
Epubcheck Version 3.0.1

Validating against EPUB version 2.0
ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(19,65): attribute "sodipodi:version" not allowed here; 

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(19,65): attribute "inkscape:version" not allowed here; 

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(19,65): value of attribute "version" is invalid; must be equal to "1.1"

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(19,65): attribute "sodipodi:docname" not allowed here; 

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(19,65): attribute "inkscape:output_extension" not allowed here; 

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(39,23): element "sodipodi:namedview" not allowed anywhere; 

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(42,14): element "rdf:RDF" not allowed anywhere; 

ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(55,51): attribute "inkscape:label" not allowed here; 


ERROR: /home/rlandmann/Documents/books/rhel/Power_Management_Guide/trunk/6-trunk/tmp/en-US/Red_Hat_Enterprise_Linux-6-Power_Management_Guide-en-US.epub/OEBPS/Common_Content/images/title_logo.svg(55,51): attribute "inkscape:groupmode" not allowed here; 

Check finished with warnings or errors

Note You need to log in before you can comment on or make changes to this bug.